diff -r e16bdc0054ce cmclient.sublime-project
--- /dev/null
+++ b/cmclient.sublime-project
@@ -0,0 +1,22 @@
+{
+	"build_systems":
+	[
+		{
+			"file_regex": "^[ ]*File \"(...*?)\", line ([0-9]*)",
+			"name": "Anaconda Python Builder",
+			"selector": "source.python",
+			"shell_cmd": "python -u \"$file\""
+		}
+	],
+	"folders":
+	[
+		{
+			"file_exclude_patterns":
+			[
+				"*.cod"
+			],
+			"follow_symlinks": true,
+			"path": "."
+		}
+	]
+}
diff -r e16bdc0054ce projects/openttd_vs100.vcxproj
--- a/projects/openttd_vs100.vcxproj
+++ b/projects/openttd_vs100.vcxproj
@@ -295,6 +295,7 @@
     <ClCompile Include="..\src\animated_tile.cpp" />
     <ClCompile Include="..\src\articulated_vehicles.cpp" />
     <ClCompile Include="..\src\autoreplace.cpp" />
+    <ClCompile Include="..\src\bitstream.cpp" />
     <ClCompile Include="..\src\bmp.cpp" />
     <ClCompile Include="..\src\cargoaction.cpp" />
     <ClCompile Include="..\src\cargomonitor.cpp" />
@@ -402,8 +403,10 @@
     <ClInclude Include="..\src\base_media_base.h" />
     <ClInclude Include="..\src\base_media_func.h" />
     <ClInclude Include="..\src\base_station_base.h" />
+    <ClInclude Include="..\src\bitstream.h" />
     <ClInclude Include="..\src\bmp.h" />
     <ClInclude Include="..\src\bridge.h" />
+    <ClInclude Include="..\src\cargo_table_gui.h" />
     <ClInclude Include="..\src\cargo_type.h" />
     <ClInclude Include="..\src\cargoaction.h" />
     <ClInclude Include="..\src\cargomonitor.h" />
@@ -647,6 +650,7 @@
     <ClInclude Include="..\src\viewport_func.h" />
     <ClInclude Include="..\src\viewport_sprite_sorter.h" />
     <ClInclude Include="..\src\viewport_type.h" />
+    <ClInclude Include="..\src\watch_gui.h" />
     <ClInclude Include="..\src\water.h" />
     <ClInclude Include="..\src\waypoint_base.h" />
     <ClInclude Include="..\src\waypoint_func.h" />
@@ -658,6 +662,7 @@
     <ClInclude Include="..\src\window_func.h" />
     <ClInclude Include="..\src\window_gui.h" />
     <ClInclude Include="..\src\window_type.h" />
+    <ClInclude Include="..\src\zoning.h" />
     <ClInclude Include="..\src\zoom_func.h" />
     <ClInclude Include="..\src\zoom_type.h" />
     <ClCompile Include="..\src\core\alloc_func.cpp" />
@@ -694,7 +699,9 @@
     <ClCompile Include="..\src\bootstrap_gui.cpp" />
     <ClCompile Include="..\src\bridge_gui.cpp" />
     <ClCompile Include="..\src\build_vehicle_gui.cpp" />
+    <ClCompile Include="..\src\cargo_table_gui.cpp" />
     <ClCompile Include="..\src\cheat_gui.cpp" />
+    <ClCompile Include="..\src\commands_gui.cpp" />
     <ClCompile Include="..\src\company_gui.cpp" />
     <ClCompile Include="..\src\console_gui.cpp" />
     <ClCompile Include="..\src\date_gui.cpp" />
@@ -743,14 +750,17 @@
     <ClCompile Include="..\src\transparency_gui.cpp" />
     <ClCompile Include="..\src\tree_gui.cpp" />
     <ClCompile Include="..\src\vehicle_gui.cpp" />
+    <ClCompile Include="..\src\watch_gui.cpp" />
     <ClCompile Include="..\src\viewport_gui.cpp" />
     <ClCompile Include="..\src\waypoint_gui.cpp" />
+    <ClCompile Include="..\src\zoning_gui.cpp" />
     <ClInclude Include="..\src\widgets\airport_widget.h" />
     <ClInclude Include="..\src\widgets\ai_widget.h" />
     <ClInclude Include="..\src\widgets\autoreplace_widget.h" />
     <ClInclude Include="..\src\widgets\bootstrap_widget.h" />
     <ClInclude Include="..\src\widgets\bridge_widget.h" />
     <ClInclude Include="..\src\widgets\build_vehicle_widget.h" />
+    <ClInclude Include="..\src\widgets\cargo_table_widget.h" />
     <ClInclude Include="..\src\widgets\cheat_widget.h" />
     <ClInclude Include="..\src\widgets\company_widget.h" />
     <ClInclude Include="..\src\widgets\console_widget.h" />
@@ -828,6 +838,7 @@
     <ClCompile Include="..\src\void_cmd.cpp" />
     <ClCompile Include="..\src\water_cmd.cpp" />
     <ClCompile Include="..\src\waypoint_cmd.cpp" />
+    <ClCompile Include="..\src\zoning_cmd.cpp" />
     <ClCompile Include="..\src\saveload\afterload.cpp" />
     <ClCompile Include="..\src\saveload\ai_sl.cpp" />
     <ClCompile Include="..\src\saveload\airport_sl.cpp" />
@@ -835,6 +846,8 @@
     <ClCompile Include="..\src\saveload\autoreplace_sl.cpp" />
     <ClCompile Include="..\src\saveload\cargomonitor_sl.cpp" />
     <ClCompile Include="..\src\saveload\cargopacket_sl.cpp" />
+    <ClCompile Include="..\src\saveload\citymania_sl.cpp" />
+    <ClInclude Include="..\src\saveload\citymania_sl.h" />
     <ClCompile Include="..\src\saveload\cheat_sl.cpp" />
     <ClCompile Include="..\src\saveload\company_sl.cpp" />
     <ClCompile Include="..\src\saveload\depot_sl.cpp" />
diff -r e16bdc0054ce projects/openttd_vs100.vcxproj.filters
--- a/projects/openttd_vs100.vcxproj.filters
+++ b/projects/openttd_vs100.vcxproj.filters
@@ -114,6 +114,9 @@
     <ClCompile Include="..\src\autoreplace.cpp">
       <Filter>Source Files</Filter>
     </ClCompile>
+    <ClCompile Include="..\src\bitstream.cpp">
+      <Filter>Source Files</Filter>
+    </ClCompile>
     <ClCompile Include="..\src\bmp.cpp">
       <Filter>Source Files</Filter>
     </ClCompile>
@@ -435,12 +438,18 @@
     <ClInclude Include="..\src\base_station_base.h">
       <Filter>Header Files</Filter>
     </ClInclude>
+    <ClInclude Include="..\src\bitstream.h">
+      <Filter>Header Files</Filter>
+    </ClInclude>
     <ClInclude Include="..\src\bmp.h">
       <Filter>Header Files</Filter>
     </ClInclude>
     <ClInclude Include="..\src\bridge.h">
       <Filter>Header Files</Filter>
     </ClInclude>
+    <ClInclude Include="..\src\cargo_table_gui.h">
+      <Filter>Header Files</Filter>
+    </ClInclude>
     <ClInclude Include="..\src\cargo_type.h">
       <Filter>Header Files</Filter>
     </ClInclude>
@@ -1170,6 +1179,9 @@
     <ClInclude Include="..\src\viewport_type.h">
       <Filter>Header Files</Filter>
     </ClInclude>
+    <ClInclude Include="..\src\watch_gui.h">
+      <Filter>Header Files</Filter>
+    </ClInclude>
     <ClInclude Include="..\src\water.h">
       <Filter>Header Files</Filter>
     </ClInclude>
@@ -1203,6 +1215,9 @@
     <ClInclude Include="..\src\window_type.h">
       <Filter>Header Files</Filter>
     </ClInclude>
+    <ClInclude Include="..\src\zoning.h">
+      <Filter>Header Files</Filter>
+    </ClInclude>
     <ClInclude Include="..\src\zoom_func.h">
       <Filter>Header Files</Filter>
     </ClInclude>
@@ -1311,9 +1326,15 @@
     <ClCompile Include="..\src\build_vehicle_gui.cpp">
       <Filter>GUI Source Code</Filter>
     </ClCompile>
+    <ClCompile Include="..\src\cargo_table_gui.cpp">
+      <Filter>GUI Source Code</Filter>
+    </ClCompile>
     <ClCompile Include="..\src\cheat_gui.cpp">
       <Filter>GUI Source Code</Filter>
     </ClCompile>
+    <ClCompile Include="..\src\commands_gui.cpp">
+      <Filter>GUI Source Code</Filter>
+    </ClCompile>
     <ClCompile Include="..\src\company_gui.cpp">
       <Filter>GUI Source Code</Filter>
     </ClCompile>
@@ -1458,12 +1479,18 @@
     <ClCompile Include="..\src\vehicle_gui.cpp">
       <Filter>GUI Source Code</Filter>
     </ClCompile>
+    <ClCompile Include="..\src\watch_gui.cpp">
+      <Filter>GUI Source Code</Filter>
+    </ClCompile>
     <ClCompile Include="..\src\viewport_gui.cpp">
       <Filter>GUI Source Code</Filter>
     </ClCompile>
     <ClCompile Include="..\src\waypoint_gui.cpp">
       <Filter>GUI Source Code</Filter>
     </ClCompile>
+    <ClCompile Include="..\src\zoning_gui.cpp">
+      <Filter>GUI Source Code</Filter>
+    </ClCompile>
     <ClInclude Include="..\src\widgets\airport_widget.h">
       <Filter>Widgets</Filter>
     </ClInclude>
@@ -1482,6 +1509,9 @@
     <ClInclude Include="..\src\widgets\build_vehicle_widget.h">
       <Filter>Widgets</Filter>
     </ClInclude>
+    <ClInclude Include="..\src\widgets\cargo_table_widget.h">
+      <Filter>Widgets</Filter>
+    </ClInclude>
     <ClInclude Include="..\src\widgets\cheat_widget.h">
       <Filter>Widgets</Filter>
     </ClInclude>
@@ -1713,6 +1743,9 @@
     <ClCompile Include="..\src\waypoint_cmd.cpp">
       <Filter>Command handlers</Filter>
     </ClCompile>
+    <ClCompile Include="..\src\zoning_cmd.cpp">
+      <Filter>Command handlers</Filter>
+    </ClCompile>
     <ClCompile Include="..\src\saveload\afterload.cpp">
       <Filter>Save/Load handlers</Filter>
     </ClCompile>
@@ -1734,6 +1767,12 @@
     <ClCompile Include="..\src\saveload\cargopacket_sl.cpp">
       <Filter>Save/Load handlers</Filter>
     </ClCompile>
+    <ClCompile Include="..\src\saveload\citymania_sl.cpp">
+      <Filter>Save/Load handlers</Filter>
+    </ClCompile>
+    <ClInclude Include="..\src\saveload\citymania_sl.h">
+      <Filter>Save/Load handlers</Filter>
+    </ClInclude>
     <ClCompile Include="..\src\saveload\cheat_sl.cpp">
       <Filter>Save/Load handlers</Filter>
     </ClCompile>
diff -r e16bdc0054ce projects/openttd_vs140.vcxproj
--- a/projects/openttd_vs140.vcxproj
+++ b/projects/openttd_vs140.vcxproj
@@ -312,6 +312,7 @@
     <ClCompile Include="..\src\animated_tile.cpp" />
     <ClCompile Include="..\src\articulated_vehicles.cpp" />
     <ClCompile Include="..\src\autoreplace.cpp" />
+    <ClCompile Include="..\src\bitstream.cpp" />
     <ClCompile Include="..\src\bmp.cpp" />
     <ClCompile Include="..\src\cargoaction.cpp" />
     <ClCompile Include="..\src\cargomonitor.cpp" />
@@ -419,8 +420,10 @@
     <ClInclude Include="..\src\base_media_base.h" />
     <ClInclude Include="..\src\base_media_func.h" />
     <ClInclude Include="..\src\base_station_base.h" />
+    <ClInclude Include="..\src\bitstream.h" />
     <ClInclude Include="..\src\bmp.h" />
     <ClInclude Include="..\src\bridge.h" />
+    <ClInclude Include="..\src\cargo_table_gui.h" />
     <ClInclude Include="..\src\cargo_type.h" />
     <ClInclude Include="..\src\cargoaction.h" />
     <ClInclude Include="..\src\cargomonitor.h" />
@@ -664,6 +667,7 @@
     <ClInclude Include="..\src\viewport_func.h" />
     <ClInclude Include="..\src\viewport_sprite_sorter.h" />
     <ClInclude Include="..\src\viewport_type.h" />
+    <ClInclude Include="..\src\watch_gui.h" />
     <ClInclude Include="..\src\water.h" />
     <ClInclude Include="..\src\waypoint_base.h" />
     <ClInclude Include="..\src\waypoint_func.h" />
@@ -675,6 +679,7 @@
     <ClInclude Include="..\src\window_func.h" />
     <ClInclude Include="..\src\window_gui.h" />
     <ClInclude Include="..\src\window_type.h" />
+    <ClInclude Include="..\src\zoning.h" />
     <ClInclude Include="..\src\zoom_func.h" />
     <ClInclude Include="..\src\zoom_type.h" />
     <ClCompile Include="..\src\core\alloc_func.cpp" />
@@ -711,7 +716,9 @@
     <ClCompile Include="..\src\bootstrap_gui.cpp" />
     <ClCompile Include="..\src\bridge_gui.cpp" />
     <ClCompile Include="..\src\build_vehicle_gui.cpp" />
+    <ClCompile Include="..\src\cargo_table_gui.cpp" />
     <ClCompile Include="..\src\cheat_gui.cpp" />
+    <ClCompile Include="..\src\commands_gui.cpp" />
     <ClCompile Include="..\src\company_gui.cpp" />
     <ClCompile Include="..\src\console_gui.cpp" />
     <ClCompile Include="..\src\date_gui.cpp" />
@@ -760,14 +767,17 @@
     <ClCompile Include="..\src\transparency_gui.cpp" />
     <ClCompile Include="..\src\tree_gui.cpp" />
     <ClCompile Include="..\src\vehicle_gui.cpp" />
+    <ClCompile Include="..\src\watch_gui.cpp" />
     <ClCompile Include="..\src\viewport_gui.cpp" />
     <ClCompile Include="..\src\waypoint_gui.cpp" />
+    <ClCompile Include="..\src\zoning_gui.cpp" />
     <ClInclude Include="..\src\widgets\airport_widget.h" />
     <ClInclude Include="..\src\widgets\ai_widget.h" />
     <ClInclude Include="..\src\widgets\autoreplace_widget.h" />
     <ClInclude Include="..\src\widgets\bootstrap_widget.h" />
     <ClInclude Include="..\src\widgets\bridge_widget.h" />
     <ClInclude Include="..\src\widgets\build_vehicle_widget.h" />
+    <ClInclude Include="..\src\widgets\cargo_table_widget.h" />
     <ClInclude Include="..\src\widgets\cheat_widget.h" />
     <ClInclude Include="..\src\widgets\company_widget.h" />
     <ClInclude Include="..\src\widgets\console_widget.h" />
@@ -845,6 +855,7 @@
     <ClCompile Include="..\src\void_cmd.cpp" />
     <ClCompile Include="..\src\water_cmd.cpp" />
     <ClCompile Include="..\src\waypoint_cmd.cpp" />
+    <ClCompile Include="..\src\zoning_cmd.cpp" />
     <ClCompile Include="..\src\saveload\afterload.cpp" />
     <ClCompile Include="..\src\saveload\ai_sl.cpp" />
     <ClCompile Include="..\src\saveload\airport_sl.cpp" />
@@ -852,6 +863,8 @@
     <ClCompile Include="..\src\saveload\autoreplace_sl.cpp" />
     <ClCompile Include="..\src\saveload\cargomonitor_sl.cpp" />
     <ClCompile Include="..\src\saveload\cargopacket_sl.cpp" />
+    <ClCompile Include="..\src\saveload\citymania_sl.cpp" />
+    <ClInclude Include="..\src\saveload\citymania_sl.h" />
     <ClCompile Include="..\src\saveload\cheat_sl.cpp" />
     <ClCompile Include="..\src\saveload\company_sl.cpp" />
     <ClCompile Include="..\src\saveload\depot_sl.cpp" />
diff -r e16bdc0054ce projects/openttd_vs140.vcxproj.filters
--- a/projects/openttd_vs140.vcxproj.filters
+++ b/projects/openttd_vs140.vcxproj.filters
@@ -114,6 +114,9 @@
     <ClCompile Include="..\src\autoreplace.cpp">
       <Filter>Source Files</Filter>
     </ClCompile>
+    <ClCompile Include="..\src\bitstream.cpp">
+      <Filter>Source Files</Filter>
+    </ClCompile>
     <ClCompile Include="..\src\bmp.cpp">
       <Filter>Source Files</Filter>
     </ClCompile>
@@ -435,12 +438,18 @@
     <ClInclude Include="..\src\base_station_base.h">
       <Filter>Header Files</Filter>
     </ClInclude>
+    <ClInclude Include="..\src\bitstream.h">
+      <Filter>Header Files</Filter>
+    </ClInclude>
     <ClInclude Include="..\src\bmp.h">
       <Filter>Header Files</Filter>
     </ClInclude>
     <ClInclude Include="..\src\bridge.h">
       <Filter>Header Files</Filter>
     </ClInclude>
+    <ClInclude Include="..\src\cargo_table_gui.h">
+      <Filter>Header Files</Filter>
+    </ClInclude>
     <ClInclude Include="..\src\cargo_type.h">
       <Filter>Header Files</Filter>
     </ClInclude>
@@ -1170,6 +1179,9 @@
     <ClInclude Include="..\src\viewport_type.h">
       <Filter>Header Files</Filter>
     </ClInclude>
+    <ClInclude Include="..\src\watch_gui.h">
+      <Filter>Header Files</Filter>
+    </ClInclude>
     <ClInclude Include="..\src\water.h">
       <Filter>Header Files</Filter>
     </ClInclude>
@@ -1203,6 +1215,9 @@
     <ClInclude Include="..\src\window_type.h">
       <Filter>Header Files</Filter>
     </ClInclude>
+    <ClInclude Include="..\src\zoning.h">
+      <Filter>Header Files</Filter>
+    </ClInclude>
     <ClInclude Include="..\src\zoom_func.h">
       <Filter>Header Files</Filter>
     </ClInclude>
@@ -1311,9 +1326,15 @@
     <ClCompile Include="..\src\build_vehicle_gui.cpp">
       <Filter>GUI Source Code</Filter>
     </ClCompile>
+    <ClCompile Include="..\src\cargo_table_gui.cpp">
+      <Filter>GUI Source Code</Filter>
+    </ClCompile>
     <ClCompile Include="..\src\cheat_gui.cpp">
       <Filter>GUI Source Code</Filter>
     </ClCompile>
+    <ClCompile Include="..\src\commands_gui.cpp">
+      <Filter>GUI Source Code</Filter>
+    </ClCompile>
     <ClCompile Include="..\src\company_gui.cpp">
       <Filter>GUI Source Code</Filter>
     </ClCompile>
@@ -1458,12 +1479,18 @@
     <ClCompile Include="..\src\vehicle_gui.cpp">
       <Filter>GUI Source Code</Filter>
     </ClCompile>
+    <ClCompile Include="..\src\watch_gui.cpp">
+      <Filter>GUI Source Code</Filter>
+    </ClCompile>
     <ClCompile Include="..\src\viewport_gui.cpp">
       <Filter>GUI Source Code</Filter>
     </ClCompile>
     <ClCompile Include="..\src\waypoint_gui.cpp">
       <Filter>GUI Source Code</Filter>
     </ClCompile>
+    <ClCompile Include="..\src\zoning_gui.cpp">
+      <Filter>GUI Source Code</Filter>
+    </ClCompile>
     <ClInclude Include="..\src\widgets\airport_widget.h">
       <Filter>Widgets</Filter>
     </ClInclude>
@@ -1482,6 +1509,9 @@
     <ClInclude Include="..\src\widgets\build_vehicle_widget.h">
       <Filter>Widgets</Filter>
     </ClInclude>
+    <ClInclude Include="..\src\widgets\cargo_table_widget.h">
+      <Filter>Widgets</Filter>
+    </ClInclude>
     <ClInclude Include="..\src\widgets\cheat_widget.h">
       <Filter>Widgets</Filter>
     </ClInclude>
@@ -1713,6 +1743,9 @@
     <ClCompile Include="..\src\waypoint_cmd.cpp">
       <Filter>Command handlers</Filter>
     </ClCompile>
+    <ClCompile Include="..\src\zoning_cmd.cpp">
+      <Filter>Command handlers</Filter>
+    </ClCompile>
     <ClCompile Include="..\src\saveload\afterload.cpp">
       <Filter>Save/Load handlers</Filter>
     </ClCompile>
@@ -1734,6 +1767,12 @@
     <ClCompile Include="..\src\saveload\cargopacket_sl.cpp">
       <Filter>Save/Load handlers</Filter>
     </ClCompile>
+    <ClCompile Include="..\src\saveload\citymania_sl.cpp">
+      <Filter>Save/Load handlers</Filter>
+    </ClCompile>
+    <ClInclude Include="..\src\saveload\citymania_sl.h">
+      <Filter>Save/Load handlers</Filter>
+    </ClInclude>
     <ClCompile Include="..\src\saveload\cheat_sl.cpp">
       <Filter>Save/Load handlers</Filter>
     </ClCompile>
diff -r e16bdc0054ce projects/openttd_vs80.vcproj
--- a/projects/openttd_vs80.vcproj
+++ b/projects/openttd_vs80.vcproj
@@ -451,6 +451,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\bitstream.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\bmp.cpp"
 				>
 			</File>
@@ -883,6 +887,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\bitstream.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\bmp.h"
 				>
 			</File>
@@ -891,6 +899,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\cargo_table_gui.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\cargo_type.h"
 				>
 			</File>
@@ -1863,6 +1875,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\watch_gui.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\water.h"
 				>
 			</File>
@@ -1907,6 +1923,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\zoning.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\zoom_func.h"
 				>
 			</File>
@@ -2059,10 +2079,18 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\cargo_table_gui.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\cheat_gui.cpp"
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\commands_gui.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\company_gui.cpp"
 				>
 			</File>
@@ -2255,6 +2283,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\watch_gui.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\viewport_gui.cpp"
 				>
 			</File>
@@ -2262,6 +2294,10 @@
 				RelativePath=".\..\src\waypoint_gui.cpp"
 				>
 			</File>
+			<File
+				RelativePath=".\..\src\zoning_gui.cpp"
+				>
+			</File>
 		</Filter>
 		<Filter
 			Name="Widgets"
@@ -2291,6 +2327,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\widgets\cargo_table_widget.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\widgets\cheat_widget.h"
 				>
 			</File>
@@ -2602,6 +2642,10 @@
 				RelativePath=".\..\src\waypoint_cmd.cpp"
 				>
 			</File>
+			<File
+				RelativePath=".\..\src\zoning_cmd.cpp"
+				>
+			</File>
 		</Filter>
 		<Filter
 			Name="Save/Load handlers"
@@ -2635,6 +2679,14 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\saveload\citymania_sl.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\saveload\citymania_sl.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\saveload\cheat_sl.cpp"
 				>
 			</File>
diff -r e16bdc0054ce projects/openttd_vs90.vcproj
--- a/projects/openttd_vs90.vcproj
+++ b/projects/openttd_vs90.vcproj
@@ -448,6 +448,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\bitstream.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\bmp.cpp"
 				>
 			</File>
@@ -880,6 +884,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\bitstream.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\bmp.h"
 				>
 			</File>
@@ -888,6 +896,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\cargo_table_gui.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\cargo_type.h"
 				>
 			</File>
@@ -1860,6 +1872,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\watch_gui.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\water.h"
 				>
 			</File>
@@ -1904,6 +1920,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\zoning.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\zoom_func.h"
 				>
 			</File>
@@ -2056,10 +2076,18 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\cargo_table_gui.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\cheat_gui.cpp"
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\commands_gui.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\company_gui.cpp"
 				>
 			</File>
@@ -2252,6 +2280,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\watch_gui.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\viewport_gui.cpp"
 				>
 			</File>
@@ -2259,6 +2291,10 @@
 				RelativePath=".\..\src\waypoint_gui.cpp"
 				>
 			</File>
+			<File
+				RelativePath=".\..\src\zoning_gui.cpp"
+				>
+			</File>
 		</Filter>
 		<Filter
 			Name="Widgets"
@@ -2288,6 +2324,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\widgets\cargo_table_widget.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\widgets\cheat_widget.h"
 				>
 			</File>
@@ -2599,6 +2639,10 @@
 				RelativePath=".\..\src\waypoint_cmd.cpp"
 				>
 			</File>
+			<File
+				RelativePath=".\..\src\zoning_cmd.cpp"
+				>
+			</File>
 		</Filter>
 		<Filter
 			Name="Save/Load handlers"
@@ -2632,6 +2676,14 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\saveload\citymania_sl.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\saveload\citymania_sl.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\saveload\cheat_sl.cpp"
 				>
 			</File>
diff -r e16bdc0054ce source.list
--- a/source.list
+++ b/source.list
@@ -3,6 +3,7 @@
 animated_tile.cpp
 articulated_vehicles.cpp
 autoreplace.cpp
+bitstream.cpp
 bmp.cpp
 cargoaction.cpp
 cargomonitor.cpp
@@ -141,8 +142,10 @@
 base_media_base.h
 base_media_func.h
 base_station_base.h
+bitstream.h
 bmp.h
 bridge.h
+cargo_table_gui.h
 cargo_type.h
 cargoaction.h
 cargomonitor.h
@@ -386,6 +389,7 @@
 viewport_func.h
 viewport_sprite_sorter.h
 viewport_type.h
+watch_gui.h
 water.h
 waypoint_base.h
 waypoint_func.h
@@ -397,6 +401,7 @@
 window_func.h
 window_gui.h
 window_type.h
+zoning.h
 zoom_func.h
 zoom_type.h
 #if WIN32
@@ -452,7 +457,9 @@
 bootstrap_gui.cpp
 bridge_gui.cpp
 build_vehicle_gui.cpp
+cargo_table_gui.cpp
 cheat_gui.cpp
+commands_gui.cpp
 company_gui.cpp
 console_gui.cpp
 date_gui.cpp
@@ -501,8 +508,10 @@
 transparency_gui.cpp
 tree_gui.cpp
 vehicle_gui.cpp
+watch_gui.cpp
 viewport_gui.cpp
 waypoint_gui.cpp
+zoning_gui.cpp
 
 # Widgets
 widgets/airport_widget.h
@@ -511,6 +520,7 @@
 widgets/bootstrap_widget.h
 widgets/bridge_widget.h
 widgets/build_vehicle_widget.h
+widgets/cargo_table_widget.h
 widgets/cheat_widget.h
 widgets/company_widget.h
 widgets/console_widget.h
@@ -590,6 +600,7 @@
 void_cmd.cpp
 water_cmd.cpp
 waypoint_cmd.cpp
+zoning_cmd.cpp
 
 # Save/Load handlers
 saveload/afterload.cpp
@@ -599,6 +610,8 @@
 saveload/autoreplace_sl.cpp
 saveload/cargomonitor_sl.cpp
 saveload/cargopacket_sl.cpp
+saveload/citymania_sl.cpp
+saveload/citymania_sl.h
 saveload/cheat_sl.cpp
 saveload/company_sl.cpp
 saveload/depot_sl.cpp
diff -r e16bdc0054ce src/bitstream.cpp
--- /dev/null
+++ b/src/bitstream.cpp
@@ -0,0 +1,58 @@
+#include "bitstream.h"
+
+// Returns 8 higher bits of s-bit integer x
+#define FIRST8(x, s) (((x) >> ((s) - 8)) & 0xFF)
+
+void BitOStream::WriteBytes(uint32 value, int amount)
+{
+	do {
+		v = (v << 8) | FIRST8(value, amount << 3);
+		f.push_back(FIRST8(v, c + 8));
+	} while (--amount);
+}
+
+void BitOStream::WriteBytes64(uint64 value, int amount)
+{
+	do {
+		v = (v << 8) | FIRST8(value, amount << 3);
+		f.push_back(FIRST8(v, c + 8));
+	} while (--amount);
+}
+
+/**
+ * Reserves memory for encoded data. Use to avoid reallocation of vector.
+ */
+void BitOStream::Reserve(int bytes)
+{
+	f.reserve(bytes);
+}
+
+/**
+ * Returns encoded data
+ */
+const u8vector &BitOStream::GetVector()
+{
+	return f;
+}
+
+/**
+ * Size of encoded data in bytes
+ */
+uint BitOStream::GetByteSize() const
+{
+	return f.size() + (c ? 1 : 0);
+}
+
+BitIStreamUnexpectedEnd _bit_i_stream_unexpected_end;
+
+uint32 BitIStream::ReadBytes(uint amount)
+{
+	uint32 res = 0;
+	while (amount--) {
+		if (i >= f.size()) {
+			throw _bit_i_stream_unexpected_end;
+		}
+		res = (res << 8) | f[i++];
+	}
+	return res;
+}
diff -r e16bdc0054ce src/bitstream.h
--- /dev/null
+++ b/src/bitstream.h
@@ -0,0 +1,41 @@
+#ifndef BITSTREAM_H
+#define BITSTREAM_H
+
+#include "stdafx.h"
+#include <vector>
+
+typedef std::vector<uint8> u8vector;
+
+class BitOStream {
+protected:
+	u8vector f;
+	uint32 c;
+	uint32 v;
+
+public:
+	BitOStream(): c(0), v(0) {}
+	virtual ~BitOStream(){}
+	void Reserve(int bytes);
+	void WriteBytes(uint32 value, int amount);
+	void WriteBytes64(uint64 value, int amount);
+	const u8vector &GetVector();
+	uint GetByteSize() const;
+};
+
+class BitIStreamUnexpectedEnd: public std::exception {
+	virtual const char* what() const throw() {
+		return "Unexpected end of bit input stream";
+	}
+};
+
+class BitIStream {
+protected:
+	u8vector &f;
+	uint32 i;
+public:
+	BitIStream(u8vector &data): f(data), i(0) {}
+	virtual ~BitIStream(){}
+	uint32 ReadBytes(uint amount);
+};
+
+#endif
diff -r e16bdc0054ce src/bridge_gui.cpp
--- a/src/bridge_gui.cpp
+++ b/src/bridge_gui.cpp
@@ -24,6 +24,7 @@
 #include "cmd_helper.h"
 #include "tunnelbridge_map.h"
 #include "road_gui.h"
+#include "tilehighlight_func.h"
 
 #include "widgets/bridge_widget.h"
 
@@ -72,6 +73,7 @@
 		DiagDirection start_direction = ReverseDiagDir(GetTunnelBridgeDirection(p1));
 		ConnectRoadToStructure(p1, start_direction);
 	}
+	StoreRailPlacementEndpoints(p1, end_tile, (TileX(p1) == TileX(end_tile)) ? TRACK_Y : TRACK_X, false);
 }
 
 /** Window class for handling the bridge-build GUI. */
diff -r e16bdc0054ce src/build_vehicle_gui.cpp
--- a/src/build_vehicle_gui.cpp
+++ b/src/build_vehicle_gui.cpp
@@ -34,7 +34,7 @@
 #include "autoreplace_func.h"
 
 #include "widgets/build_vehicle_widget.h"
-
+#include "hotkeys.h"
 #include "table/strings.h"
 
 #include "safeguards.h"
@@ -1481,13 +1481,28 @@
 	{
 		this->vscroll->SetCapacityFromWidget(this, WID_BV_LIST);
 	}
+
+	virtual EventState OnHotkey(int hotkey)
+	{
+		if (this->owner != _local_company) return ES_NOT_HANDLED;
+		return Window::OnHotkey(hotkey);
+	}
+
+	static HotkeyList hotkeys;
 };
 
+static Hotkey build_vehicle_hotkeys[] = {
+	Hotkey('R', "build_vehicle", WID_BV_BUILD),
+	HOTKEY_LIST_END
+};
+HotkeyList BuildVehicleWindow::hotkeys("build_vehicle", build_vehicle_hotkeys);
+
 static WindowDesc _build_vehicle_desc(
 	WDP_AUTO, "build_vehicle", 240, 268,
 	WC_BUILD_VEHICLE, WC_NONE,
 	WDF_CONSTRUCTION,
-	_nested_build_vehicle_widgets, lengthof(_nested_build_vehicle_widgets)
+	_nested_build_vehicle_widgets, lengthof(_nested_build_vehicle_widgets),
+	&BuildVehicleWindow::hotkeys
 );
 
 void ShowBuildVehicleWindow(TileIndex tile, VehicleType type)
